import 'package:hqsoft_core/core_base/core_base.dart';
import 'package:intl/intl.dart';

class DateHelper {
  DateHelper._();

  static String jsonDateStringFormat = "MM/dd/yyyy HH:mm:ss";

  static String getStringJson(DateTime date) {
    return DateFormat(jsonDateStringFormat).format(date);
  }

  static String getStringJsonFormat(DateTime date, String format) {
    return DateFormat(format).format(date);
  }

  static String getStringJsonFormatLang(DateTime date, String format) {
    if (allTranslations.currentLanguage == 'vi') {
      return DateFormat(format, 'vi').format(date);
    } else {
      return DateFormat(format).format(date);
    }
  }

  static String getStringJsonFormatPicker(DateTime date) {
    if (allTranslations.currentLanguage == 'vi') {
      return DateFormat("dd/MM/yyyy").format(date);
    } else
      return DateFormat("MM/dd/yyyy").format(date);
  }

  static DateTime getDate(String date) {
    return DateTime.parse(date).toLocal();
  }

  static String getDateStandard(DateTime date) {
    if (allTranslations.currentLanguage == 'vi') {
      return DateFormat("dd/MM/yyyy").format(date);
    } else
      return DateFormat("MM/dd/yyyy").format(date);
  }
}
